%{!?lua_abi:         %define lua_abi         %(pkg-config lua --variable="V"            2>/dev/null || echo 'None')}
%{!?lua_sitelib:     %define lua_sitelib     %(pkg-config lua --variable="INSTALL_LMOD" 2>/dev/null || echo 'None')}
%{!?lua_sitearch:    %define lua_sitearch    %(pkg-config lua --variable="INSTALL_CMOD" 2>/dev/null || echo 'None')}

%{!?perl_version:    %define perl_version    %(eval "`%{__perl} -V:version`"          ; echo $version)}
%{!?perl_archlib:    %define perl_archlib    %(eval "`%{__perl} -V:installarchlib`"   ; echo $installarchlib)}
%{!?perl_vendorlib:  %define perl_vendorlib  %(eval "`%{__perl} -V:installvendorlib`" ; echo $installvendorlib)}
%{!?perl_vendorarch: %define perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)}

%{!?python_abi:      %define python_abi      %(%{__python} -c "import sys; print sys.version[:3]")}
%{!?python_sitelib:  %define python_sitelib  %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

%{!?ruby_abi:        %define ruby_abi        %(ruby -rrbconfig -e "puts Config::CONFIG['ruby_version']" 2>/dev/null || echo 'None')}
%{!?ruby_sitelib:    %define ruby_sitelib    %(ruby -rrbconfig -e "puts Config::CONFIG['sitelibdir']"   2>/dev/null || echo 'None')}
%{!?ruby_sitearch:   %define ruby_sitearch   %(ruby -rrbconfig -e "puts Config::CONFIG['sitearchdir']"  2>/dev/null || echo 'None')}

%{!?tcl_version:     %define tcl_version     %(echo 'puts $tcl_version' | tclsh || echo 'None')}
%{!?tcl_sitelib:     %define tcl_sitelib     %{_datadir}/tcl%{tcl_version}}
%{!?tcl_sitearch:    %define tcl_sitearch    %{_libdir}/tcl%{tcl_version}}


Summary:          Time-series data logging and graphing tools
Name:             rrdtool
Version:          1.4.7
Release:          1%{?dist}%{?pext}
License:          GPL
Group:            Applications/Databases
Source0:          http://oss.oetiker.ch/%{name}/pub/%{name}-%{version}.tar.gz
Source1:          rrdcached.init
Source2:          rrdcached.sysconfig
Patch0:           %{name}-1.3.8-ruby.patch
URL:              http://www.mrtg.org/%{name}/
Buildroot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:           Tobias Oetiker <tobi@oetiker.ch>
Requires:         bitstream-vera-fonts
BuildRequires:    bitstream-vera-fonts cairo-devel gettext
BuildRequires:    groff intltool libdbi-devel libxml2-devel
BuildRequires:    pango-devel pkgconfig tcp_wrappers lua-devel
BuildRequires:    lua perl(Config) perl(ExtUtils::MakeMaker)
BuildRequires:    python-devel >= 2.3 python-setuptools
BuildRequires:    ruby ruby-devel tcl-devel

%description
RRD is the Acronym for Round Robin Database. RRD is a system to store and
display time-series data (i.e. network bandwidth, machine-room temperature,
server load average). It stores the data in a very compact way that will not
expand over time, and it presents useful graphs by processing the data to
enforce a certain data density.


%package          cache
Summary:          The data caching daemon for RRDTool
Group:            System Environment/Daemons
Requires:         %{name} = %{version}-%{release}
Requires(pre):    /usr/sbin/groupadd /usr/sbin/useradd
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/chkconfig /sbin/service
Requires(postun): /sbin/service

%description      cache
The %{name}-cache package contains the data caching daemon for RRDTool. The
daemon receives updates to existing RRD files, accumulates them and writes
the updates to the RRD file. It was written with big setups in mind, which
usually run into IO related problems sooner or later.


%package          devel
Summary:          Development tools for RRDTool
Group:            Development/Libraries
Requires:         %{name} = %{version}-%{release}
Requires:         cairo-devel libdbi-devel libxml2-devel
Requires:         pango-devel pkgconfig tcp_wrappers

%description      devel
The %{name}-devel package contains the static libraries and header files
for developing software using RRDTool.


%package          doc 
Summary:          The RRDTool documentation
Group:            Documentation

%description      doc
The %{name}-doc package contains the complete RRDTool documentation in HTML
and TXT format.


%package       -n lua-%{name}
Summary:          Lua bindings for RRDTool
Group:            Development/Languages
Provides:         %{name}-lua = %{version}
Provides:         lua(rrd) = %{version}
Requires:         %{name} = %{version}-%{release}
Requires:         lua(abi) = %{lua_abi}

%description   -n lua-%{name}
The lua-%{name} package contains the Lua bindings for RRDTool.


%package       -n perl-%{name}
Summary:          Perl bindings for RRDTool
Group:            Development/Libraries
Provides:         %{name}-perl = %{version}
Provides:         perl(RRDp) = 1.4007
Provides:         perl(RRDs) = 1.4007
Requires:         %{name} = %{version}-%{release}
Requires:         perl(:MODULE_COMPAT_%{perl_version})

%description   -n perl-%{name}
The perl-%{name} package contains the Perl bindings for RRDTool.


%package       -n python-%{name}
Summary:          Python bindings for RRDTool
License:          LGPL
Group:            Development/Languages
Provides:         %{name}-python = %{version}
Provides:         python(%{name}) = 0.2.1
Requires:         %{name} = %{version}-%{release}

%description   -n python-%{name}
The python-%{name} package contains the Python bindings for RRDTool.


%package       -n ruby-%{name}
Summary:          Ruby bindings for RRDTool
Group:            Development/Languages
Provides:         %{name}-ruby = %{version}
Provides:         ruby(RRD) = %{version}
Requires:         %{name} = %{version}-%{release}
Requires:         ruby(abi) = %{ruby_abi}

%description   -n ruby-%{name}
The ruby-%{name} package contains the Ruby bindings for RRDTool.


%package       -n tcl-%{name}
Summary:          Tcl bindings for RRDTool
Group:            Development/Languages
Provides:         %{name}-tcl = %{version}
Provides:         tcl(rrd) = %{version}
Provides:         tclrrd = %{version}
Requires:         %{name} = %{version}-%{release}
#Requires:        tcl(abi) = %{tcl_version}
Requires:         tcl >= %{tcl_version}

%description   -n tcl-%{name}
The tcl-%{name} package contains the Tcl bindings for RRDTool.


%prep
%setup -q
%patch0 -p1

# Fix socket path for rrdcached
for FILE in `find . -type f -exec fgrep -l "rrdcached.sock" {} \;`; do
  %{__perl} -i -pe 's+/.*rrdcached.sock+%{_localstatedir}/run/rrdcached/rrdcached.sock+g' ${FILE}
done


%build
%configure \
	--enable-shared     \
	--enable-static     \
	--disable-lua       \
	--disable-perl      \
	--disable-python    \
	--disable-rpath     \
	--disable-ruby      \
	--enable-tcl        \
	--enable-tcl-site   \
	--with-tcllib=%{_libdir}

%{__make} V=1 %{?_smp_mflags}

# Build Lua bindings
pushd bindings/lua
%{__make} \
	LUA_INSTALL_CMOD=%{lua_sitearch} \
	LUA_INSTALL_LMOD=%{lua_sitelib}  \
	%{?_smp_mflags}
popd

# Build Perl bindings
for TYPE in piped shared; do
  pushd bindings/perl-${TYPE}
  %{__perl} \
	Makefile.PL          \
	INSTALLDIRS="vendor" \
	OPTIMIZE="${RPM_OPT_FLAGS}"
  %{__make} %{?_smp_mflags}
  popd
done

# Build Python bindings
pushd bindings/python
%{__python} -c 'import setuptools; execfile("setup.py")' build
popd

# Build Ruby bindings
pushd bindings/ruby
export CONFIGURE_ARGS="--with-cflags=\"${RPM_OPT_FLAGS}\""
ruby extconf.rb
%{__make} %{?_smp_mflags}
popd


%check
export LD_LIBRARY_PATH=%{_builddir}/%{name}-%{version}/src/.libs

# Test Lua bindings
pushd bindings/lua
%{__make} \
	LUA_INSTALL_CMOD=./.libs \
	LUA_INSTALL_LMOD=./.libs \
	test
popd

# Test Perl bindings
for TYPE in piped shared; do
  pushd bindings/perl-${TYPE}
  %{__make} test
  popd
done

# Test Ruby bindings
pushd bindings/ruby
ruby test.rb
popd


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_initrddir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sbindir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{lua_sitearch}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_localstatedir}/lib/rrdcached/{db,jnl}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_localstatedir}/run/rrdcached

%{__make} \
	DESTDIR=${RPM_BUILD_ROOT} \
	install

%{__mv}      -f      ${RPM_BUILD_ROOT}%{_bindir}/rrdcached ${RPM_BUILD_ROOT}%{_sbindir}

%{__install} -m 0755 %{SOURCE1} ${RPM_BUILD_ROOT}%{_initrddir}/rrdcached
%{__install} -m 0644 %{SOURCE2} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/rrdcached

%{__rm}      -rf     ${RPM_BUILD_ROOT}%{_docdir}
%{__rm}      -f      ${RPM_BUILD_ROOT}%{_libdir}/lib*.so.?

# Install Lua bindings
pushd bindings/lua
%{__cp} -a .libs/rrd.so* ${RPM_BUILD_ROOT}%{lua_sitearch}
popd

# Install Perl bindings
for TYPE in piped shared; do
  pushd bindings/perl-${TYPE}
  %{__make} \
	PERL_INSTALL_ROOT=${RPM_BUILD_ROOT} \
	pure_install
  popd
done

find ${RPM_BUILD_ROOT}%{perl_archlib}    -type f -name "perl*.pod"       -exec %{__rm} -f {} \;
find ${RPM_BUILD_ROOT}%{perl_vendorarch} -type f -name "ntmake.pl"       -exec %{__rm} -f {} \;
find ${RPM_BUILD_ROOT}%{perl_vendorarch} -type f -name ".packlist"       -exec %{__rm} -f {} \;
find ${RPM_BUILD_ROOT}%{perl_vendorarch} -type f -name "*.bs" -a -size 0 -exec %{__rm} -f {} \;
find ${RPM_BUILD_ROOT}%{perl_vendorarch} -depth  -empty -type d          -exec rmdir      {} \;

%{__chmod} -R u+w ${RPM_BUILD_ROOT}%{perl_vendorarch}/*

# Install Python bindings
pushd bindings/python
%{__python} -c 'import setuptools; execfile("setup.py")' install \
	--skip-build -O1 --root ${RPM_BUILD_ROOT}
popd

# Install Ruby bindings
pushd bindings/ruby
%{__make} \
	DESTDIR=${RPM_BUILD_ROOT} \
	install
popd


%pre cache
if ! getent group  rrdcached >/dev/null 2>&1; then
  /usr/sbin/groupadd -r rrdcached
fi
if ! getent passwd rrdcached >/dev/null 2>&1; then
  /usr/sbin/useradd  -r -g rrdcached       \
	-d %{_localstatedir}/lib/rrdcached \
	-c "Rrdcached Service user" -M     \
	-s /sbin/nologin rrdcached
fi
exit 0			# Always pass


%post -p /sbin/ldconfig

%post cache
/sbin/chkconfig --add rrdcached


%preun cache
if [ $1 -eq 0 ]; then	# Remove
  /sbin/service rrdcached stop >/dev/null 2>&1
  /sbin/chkconfig --del rrdcached
fi


%postun -p /sbin/ldconfig

%postun cache
if [ $1 -ge 1 ]; then	# Upgrade
  /sbin/service rrdcached condrestart >/dev/null 2>&1 || :
fi


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc CHANGES CONTRIBUTORS COPY* NEWS README THREADS TODO
%{_bindir}/rrdcgi
%{_bindir}/rrdtool
%{_bindir}/rrdupdate
%{_libdir}/librrd.so.*
%{_libdir}/librrd_th.so.*
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/examples
%{_datadir}/%{name}/examples/*.cgi
%{_mandir}/man1/*.1*
%exclude %{_mandir}/man1/rrdcached.1*

%files cache
%defattr(-,root,root)
%{_initrddir}/rrdcached
%config(noreplace) %{_sysconfdir}/sysconfig/rrdcached
%{_sbindir}/rrdcached
%{_datadir}/%{name}/examples/rrdcached
%{_mandir}/man1/rrdcached.1*
%attr(750,rrdcached,rrdcached) %dir %{_localstatedir}/lib/rrdcached
%attr(770,rrdcached,rrdcached) %dir %{_localstatedir}/lib/rrdcached/db
%attr(750,rrdcached,rrdcached) %dir %{_localstatedir}/lib/rrdcached/jnl
%attr(750,rrdcached,rrdcached) %dir %{_localstatedir}/run/rrdcached

%files devel
%defattr(-,root,root)
%{_includedir}/rrd.h
%{_includedir}/rrd_client.h
%{_includedir}/rrd_format.h
%{_libdir}/librrd.*a
%{_libdir}/librrd.so
%{_libdir}/librrd_th.*a
%{_libdir}/librrd_th.so
%{_libdir}/pkgconfig/librrd.pc
%{_mandir}/man3/librrd.3*

%files doc
%defattr(-,root,root)
%doc doc/rrd*.html doc/rrd*.txt *.ico

%files -n lua-%{name}
%defattr(-,root,root)
%doc bindings/lua/README
%{lua_sitearch}/rrd.so*

%files -n perl-%{name}
%defattr(-,root,root)
%doc doc/{RRDp,RRDs}.html
%{perl_vendorlib}/RRDp.pm
%{perl_vendorarch}/auto/RRDs
%{perl_vendorarch}/RRDs.pm
%{_datadir}/%{name}/examples/*.pl
%{_mandir}/man3/RRD*.3*

%files -n python-%{name}
%defattr(-,root,root)
%doc bindings/python/{ACKNOWLEDGEMENT,AUTHORS,COPYING,README}
%{python_sitearch}/rrdtoolmodule.so
%{python_sitearch}/*.egg-info

%files -n ruby-%{name}
%defattr(-,root,root)
%doc bindings/ruby/{CHANGES,README}
%{ruby_sitearch}/RRD.so

%files -n tcl-%{name}
%defattr(-,root,root)
%doc bindings/tcl/README
%{_libdir}/%{name}
%{_libdir}/tclrrd*.so


%changelog
* Mon Mar 19 2012 Peter Pramberger <peterpramb@member.fsf.org> - 1.4.7-1
- New version (1.4.7)

* Fri Feb 11 2011 Peter Pramberger <peterpramb@member.fsf.org> - 1.4.5-1
- New version (1.4.5)

* Tue Oct 27 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.9-1
- New version (1.3.9)

* Tue Aug 25 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.8-2
- Build Ruby bindings

* Fri May 29 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.8-1
- New version (1.3.8)

* Thu Apr 09 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.7-1
- New version (1.3.7)

* Sat Jan 24 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.6-1
- New version (1.3.6)

* Fri Dec 19 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.5-1
- New version (1.3.5)

* Sun Nov 23 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.4-1
- Upgrade version (1.3.4)

* Wed May 09 2007 peter.pramberger@member.fsf.org 1.2.23-4
- new version (1.2.23)

* Thu Feb 08 2007 peter.pramberger@member.fsf.org 1.2.19-4
- new version (1.2.19)

* Thu Sep 07 2006 peter.pramberger@member.fsf.org
- new version (1.2.15)

* Fri Mar 03 2006 peter.pramberger@member.fsf.org
- created
